/* Pack a file into the TI-Pack format.           *\
)* USAGE: tipack [Source File] [Destination File] *(
\* Programmed by Linus Akesson in 1998.           */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define WSWAP(x) (((x<<8)&0xff00)|((x>>8)&0x00ff))

#define BITS_READ     3
#define BITS_COPYPOS  6
#define BITS_COPYLEN  3

char *packbuffer, *cmdbuffer, cmdbyte;
long fullsize = 0, cmdsize = 0, packsize = 0;
int cmdbits = 0;
char error = FALSE;

putbit(char bit)
{
   cmdbyte = ((cmdbyte>>1)&0x7f)|(bit? 0x80:0x00);
   if(++cmdbits==8)
   {
      cmdbits = 0;
      cmdsize++;
      *(--cmdbuffer) = cmdbyte;
      if(packsize+cmdsize+1>=fullsize) error = TRUE;
   }
}

main(int argc, char **argv)
{
   FILE *src, *dest;
   char ch, *fullbuffer;
   int i, j, x, b, record, recpos, num, readcount = 0;
   char ok;
   unsigned short swapword;

   printf("TI-Pack by Linus Akesson.\n");
   if(argc!=3)
   {
      printf("USAGE: %s [Source File] [Destination File]\n", argv[0]);
   }
   else
   {
      if(src = fopen(argv[1], "rb"))
      {
         while(fread(&ch, 1, 1, src)) fullsize++;
         printf("Unpacked size: %ld\n", fullsize);
         fseek(src, 0, 0);
         if(fullbuffer = malloc(fullsize))
         {
            if(packbuffer = malloc(fullsize))
            {
               cmdbuffer = &packbuffer[fullsize];
               fread(fullbuffer, sizeof(char), fullsize, src);

               for(i=0;i<fullsize && !error;i++)
               {
                  record = 0;
                  if(i>1)
                  {
                     for(j=(i>=((1<<BITS_COPYPOS)+1)? i-((1<<BITS_COPYPOS)+1) : 0); j<i-1; j++)
                     {
                        num = 0; ok = TRUE;
                        for(x=j; x<(j+(1<<BITS_COPYLEN)<i? j+(1<<BITS_COPYLEN) : i) && ok; x++)
                        {
                           if(fullbuffer[i-j+x] == fullbuffer[x])
                           {
                              num++;
                           }
                           else
                           {
                              ok = FALSE;
                           }
                        }
                        if(num>record) {record = num; recpos = i-j-2;}
                     }
                  }
                  if(record>1)
                  {
                     if(readcount)
                     {
                        putbit(0);
                        readcount--;
                        for(b=BITS_READ-1;b>=0;b--)
                           putbit(readcount&(1<<b));
                        readcount = 0;
                     }
                     putbit(1);
                     for(b=BITS_COPYPOS-1;b>=0;b--)
                        putbit(recpos&(1<<b));
                     record--;
                     for(b=BITS_COPYLEN-1;b>=0;b--)
                        putbit(record&(1<<b));
                     i += record;
                  }
                  else
                  {
                     readcount++;
                     packbuffer[packsize] = fullbuffer[i];
                     packsize++;
                     if(packsize+cmdsize+1>=fullsize)
                     {
                        error = TRUE;
                     }
                     else
                     {
                        if(readcount>(1<<BITS_READ))
                        {
                           readcount-=2;
                           putbit(0);
                           for(b=BITS_READ-1;b>=0;b--)
                              putbit(readcount&(1<<b));
                           readcount = 1;
                        }
                     }
                  }
               }

               if(error)
               {
                  printf("Couldn't pack file!\n");
               }
               else
               {
                  if(readcount)
                  {
                     readcount--;
                     putbit(0);
                     for(b=BITS_READ-1;b>=0;b--)
                        putbit(readcount&(1<<b));
                     readcount = 0;
                  }

                  while(cmdbits) putbit(0);
                  if(error)
                  {
                     printf("Couldn't pack file!\n");
                  }
                  else
                  {
                     if(dest = fopen(argv[2], "wb"))
                     {
                        swapword = WSWAP(packsize+cmdsize+3);
                        fwrite(&swapword, sizeof(swapword), 1, dest);
                        fwrite("P", sizeof(char), 1, dest);
                        swapword = WSWAP(fullsize);
                        fwrite(&swapword, sizeof(swapword), 1, dest);
                        fwrite(packbuffer, sizeof(char), packsize, dest);
                        fwrite(cmdbuffer, sizeof(char), cmdsize, dest);
                        fclose(dest);
                        printf("Packed size: %ld\n", packsize + cmdsize + 5);
                     }
                  }
               }

               free(packbuffer);
               }
            free(fullbuffer);
            }
         fclose(src);
      }
   }
}

