; Custom zasmload for Stranded, v2.

_ldHLind	equ	4000h
_CHKFINDSYM	equ	442ah
_ERRUNDEFINED	equ	467bh
_ERRNOTENOUGHMEM equ	464eh
_INSERTMEM	equ	4432h
_A2POINTHLIND	equ	4036h
usermem_offset	equ	8565h

		org     9327h

size		equ	1a60h
addsize		equ	390			;biggest txt#?.asm.bin

		ld	hl,filename
		rst	32

		ld	hl,size+addsize
		;push	hl
		ld	de,insert_start-9327h
		or	a
		sbc	hl,de
		push	hl
		call	_ERRNOTENOUGHMEM
		pop	hl
		push	hl
		ld	de,insert_start
		call	_INSERTMEM
		pop	hl
		push	hl
		ld	de,(usermem_offset)
		add	hl,de
		ld	(usermem_offset),hl
		pop	hl
		ld	de,insert_start
		add	hl,de			;new address of loader
		jp	(hl)

filename:	defm	5,"ZSTRANDZ"

insert_start:	call	_CHKFINDSYM
		jp	c,_ERRUNDEFINED

		ex      de,hl
		push	hl
		ld	a,4
		call	_A2POINTHLIND
		pop	de
		add	hl,de

		ld	de,9327h
		push	de

		;call	Unpack
		;ret	;jp	9327h


; ===================================================
; === unpack - Unpack data.                       ===
; === INPUTS: hl is packed data (with packedsize) ===
; ===         de is allocated memory              ===
; ===================================================

Unpack:		ld	(up_destptr),de
		ld	c,(hl)
		inc	hl
		ld	b,(hl)		;bc is packedsize
		inc	hl
		inc	hl		;get past 'P'
		ld	e,(hl)
		inc	hl
		ld	d,(hl)		;de is originalsize
		inc	hl
		ld	(up_srcptr),hl
		dec	hl
		dec	hl
		dec	hl
		add	hl,bc		;hl is past end of command table
		push	hl
		ld	hl,(up_destptr)
		add	hl,de
		ld	(up_endptr),hl
		pop	hl

		ld	a,1

up_parseloop:	push	hl
		ld	hl,(up_endptr)
		ld	de,(up_destptr)
		scf
		sbc	hl,de
		pop	hl
		ret	c		;done

		cp	1
		rra
		call	z,up_newbyte_REL

		jr	c,up_cmdcopy

		ld	b,3		;BITS_READ
		call	up_read_REL
		push	hl
		ld	hl,(up_srcptr)
		ld	de,(up_destptr)
		;inc	c
		ldir
		ld	(up_srcptr),hl
		ld	(up_destptr),de
		pop	hl
		jr	up_parseloop

up_cmdcopy:	ld	b,6		;BITS_COPYPOS
		call	up_read_REL
		push	hl
		ld	hl,(up_destptr)
		ld	e,l
		ld	d,h
		;inc	c
		scf
		sbc	hl,bc
		ex	(sp),hl
		ld	b,3		;BITS_COPYLEN
		call	up_read_REL
		ex	(sp),hl
		;inc	c
		ldir
		ld	(up_destptr),de
		pop	hl
		jr	up_parseloop

up_newbyte:	dec	hl
		ld	a,(hl)
		scf
		rra
		ret

up_read:	ld	c,0
up_r_1:		cp	1
		rra
		call	z,up_newbyte_REL
		rl	c
		djnz	up_r_1
		inc	c
		ret

up_newbyte_REL	equ	up_newbyte+size+addsize+9327h-insert_start
up_read_REL	equ	up_read+size+addsize+9327h-insert_start

up_endptr	equ	8039h
up_srcptr	equ	803bh
up_destptr	equ	803dh
